// --------------------------------------------------- 
// University of California Santa Barbara
// Media Arts and Technology
// MAT 259 | Visualizing Information | Winter 2011
//
// Patrick Rudolph
// Project 3 | Animation
//
// Loading the data from the database
// ---------------------------------------------------  

import de.bezier.data.sql.*;

// --------------------------------------------------- 
//   GLOBAL VARIABLES
// --------------------------------------------------- 
MySQL db;
String user     = "mat259";
String pass     = "V1sual1zat1on";
String database = "spl_all";

String[][] topics = new String[5][2];

// --------------------------------------------------- 
//   INITIALIZING (runs only once)
// --------------------------------------------------- 
void setup()
{
  size(100,100); 
  frameRate(1);
  int s,sum;
  
  topics[0][0] = "WHERE ( title LIKE '%Soccer%' ";
  for(s=1;s<2;s++) topics[0][0] += "OR subject"+s+" LIKE '%Soccer%' ";
  topics[0][1] = "soccer";
  topics[1][0] = "WHERE ( title LIKE '%Obama%' ";
  for(s=1;s<2;s++) topics[1][0] += "OR subject"+s+" LIKE '%Obama%' ";
  topics[1][1] = "obama";
  topics[2][0] = "WHERE ( title LIKE '%Bush%' ";
  for(s=1;s<2;s++) topics[2][0] += "OR subject"+s+" LIKE '%Bush%' ";
  topics[2][1] = "bush";
  topics[3][0] = "WHERE ( title LIKE '%Global Warming%' OR title LIKE '%Climate Change%' ";
  for(s=1;s<2;s++) topics[3][0] += "OR subject"+s+" LIKE '%Global Warming%' OR subject"+s+" LIKE '%Climate Change%' ";
  topics[3][1] = "globalwarming";
  topics[4][0] = "WHERE ( title LIKE '%National Park%' OR title LIKE '%National Park%' ";
  for(s=1;s<2;s++) topics[4][0] += "OR subject"+s+" LIKE '%National Park%' OR subject"+s+" LIKE '%National Park%' ";
  topics[4][1] = "nationalparks";
  
  
  println("Welcome. This program loads data for project #3 from tango and saves it to a file.");
  
  // connect to database
  print("Connecting to database.. ");
  db = new MySQL( this, "tango.mat.ucsb.edu", database, user, pass );  
  
  if( db.connect() ) 
  {
    println("done.");

    for(int t = 0; t < topics.length; t++)
    {
      ArrayList items = new ArrayList();
      sum = 0;
      String query = "";
      
      query = "SELECT DATEDIFF(ckoutDateTime,'2006-01-01'),SUBSTR(deweyClass,1,3) FROM transactionsallID ";
      query += topics[t][0];
      query += ") AND year(ckoutDateTime) >= 2006 AND year(ckoutDateTime) <= 2010 ";
      query += "GROUP BY concat(barcode,ckoutDateTime) ";
      query += "ORDER BY DATEDIFF(ckoutDateTime,'2006-01-01') ASC;";
      
      // query database
      print("Loading data for topic #" + t + ".. ");
      db.query(query);
      while(db.next())
      {
        // parse/filter
        
        // add item to ArrayList
        String item = db.getInt(1)+","+db.getString(2);
        items.add(item);
        sum++;
      }
      println("done.");
      
      // write to file
      String[] saveString = new String[items.size()+1];
      for(int i = 0; i < items.size(); i++)
        saveString[i] = (String) items.get(i);       
      saveString[items.size()] = sum+"";
      
      saveStrings("../"+topics[t][1]+".txt",saveString);     

    }
    print("Closing database.. ");
    db.close();
    println("done.");
  }
  else
  {
    // connection failed
    print("failed.");
  }  
}

// --------------------------------------------------- 
//   DRAWING (runs at framerate, default 60 frames/s)
// --------------------------------------------------- 
void draw() {}
